<h1 align="center">code-edit</h1>

<p align="center">
lightweight (~5kb) code editor custom element with syntax highlighting
</p>

<p align="center">
   <a href="#install">        🔧 <strong>Install</strong></a>
 · <a href="#example">        🧩 <strong>Example</strong></a>
 · <a href="#api">            📜 <strong>API docs</strong></a>
 · <a href="https://github.com/stagas/code-edit/releases"> 🔥 <strong>Releases</strong></a>
 · <a href="#contribute">     💪🏼 <strong>Contribute</strong></a>
 · <a href="https://github.com/stagas/code-edit/issues">   🖐️ <strong>Help</strong></a>
</p>

***

## Install

```sh
$ npm i code-edit
```

## API

<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

#### Table of Contents

*   [CodeEditElement](#codeeditelement)
*   [HTMLCodeEditElement](#htmlcodeeditelement)
    *   [value](#value)
    *   [language](#language)
    *   [syntax](#syntax)
    *   [theme](#theme)
    *   [tabsize](#tabsize)
    *   [tabstyle](#tabstyle)
    *   [comments](#comments)
    *   [autofocus](#autofocus)
    *   [autoresize](#autoresize)

### CodeEditElement

[src/index.ts:114-237](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L114-L237 "Source code on GitHub")

**Extends HTMLElement**

CodeEdit custom element

```js
import { CodeEditElement } from 'code-edit'
customElements.define('code-edit', CodeEditElement)
```

```html
<code-edit autofocus autoresize language="js" theme="deep"> ... </code-edit>
```

### HTMLCodeEditElement

[src/index.ts:81-100](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L81-L100 "Source code on GitHub")

CodeEdit HTML/JSX Interface

#### value

[src/index.ts:83-83](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L83-L83 "Source code on GitHub")

The editor's value

Type: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)

#### language

[src/index.ts:85-85](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L85-L85 "Source code on GitHub")

Language for syntax highlighting

Type: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)

#### syntax

[src/index.ts:87-87](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L87-L87 "Source code on GitHub")

Passing a syntax definition regexp manually

Type: (SyntaxDefinition | [Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)<{default: SyntaxDefinition}>)

#### theme

[src/index.ts:89-89](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L89-L89 "Source code on GitHub")

Theme to use

Type: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)

#### tabsize

[src/index.ts:91-91](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L91-L91 "Source code on GitHub")

Tab size

Type: [number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)

#### tabstyle

[src/index.ts:93-93](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L93-L93 "Source code on GitHub")

Tab style

Type: (`"tabs"` | `"spaces"`)

#### comments

[src/index.ts:95-95](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L95-L95 "Source code on GitHub")

Comments are defined as a tuple-like string: '// /\* \*/' first item is single comment and second third are multiline comments

Type: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)

#### autofocus

[src/index.ts:97-97](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L97-L97 "Source code on GitHub")

Autofocus to the element when page loads

Type: [boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)

#### autoresize

[src/index.ts:99-99](https://github.com/stagas/code-edit/blob/db8497df918384c2627474bb5712ef64849df096/src/index.ts#L99-L99 "Source code on GitHub")

Whether to autoresize to the height of the contents

Type: [boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)

## Contribute

[Fork](https://github.com/stagas/code-edit/fork) or
[edit](https://github.dev/stagas/code-edit) and submit a PR.

All contributions are welcome!

## License

MIT © 2022
[stagas](https://github.com/stagas)
